// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    DrucksacheDatei,
    DrucksacheMetadaten,
    VerteilungResponseDTO,
} from '../models';

export interface GetDrucksacheDateiRequest {
    body: string;
}

export interface GetDrucksacheDateiMetadatenRequest {
    body: string;
}

export interface UpdateVerteilungRequest {
    body: string;
}

/**
 * no description
 */
export class EDokControllerApi extends BaseAPI {

    /**
     * Die Drucksache als Datei kann anhand der Drucksachennummer von der E-Gesetzgebung abgerufen werden.
     * Abruf der Drucksache als Datei
     */
    getDrucksacheDatei({ body }: GetDrucksacheDateiRequest): Observable<DrucksacheDatei>
    getDrucksacheDatei({ body }: GetDrucksacheDateiRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksacheDatei>>
    getDrucksacheDatei({ body }: GetDrucksacheDateiRequest, opts?: OperationOpts): Observable<DrucksacheDatei | AjaxResponse<DrucksacheDatei>> {
        throwIfNullOrUndefined(body, 'body', 'getDrucksacheDatei');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DrucksacheDatei>({
            url: '/eDok/api/v1/BT-drucksache-datei',
            method: 'POST',
            headers,
            body: body as any,
        }, opts?.responseOpts);
    };

    /**
     * Die Metadaten zu einer Drucksache können anhand der Drucksachennummer von der E-Gesetzgebung abgerufen werden.
     * Abruf der Metadaten einer Drucksache
     */
    getDrucksacheDateiMetadaten({ body }: GetDrucksacheDateiMetadatenRequest): Observable<DrucksacheMetadaten>
    getDrucksacheDateiMetadaten({ body }: GetDrucksacheDateiMetadatenRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksacheMetadaten>>
    getDrucksacheDateiMetadaten({ body }: GetDrucksacheDateiMetadatenRequest, opts?: OperationOpts): Observable<DrucksacheMetadaten | AjaxResponse<DrucksacheMetadaten>> {
        throwIfNullOrUndefined(body, 'body', 'getDrucksacheDateiMetadaten');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DrucksacheMetadaten>({
            url: '/eDok/api/v1/BT-drucksache-metadaten',
            method: 'POST',
            headers,
            body: body as any,
        }, opts?.responseOpts);
    };

    /**
     * API der E-Gesetzgebung zur Übermittlung des Status und Datums der VerteilungDTO einer Drucksache des Bundestags.
     * Information zur VerteilungDTO einer Drucksache des Bundestags.
     */
    updateVerteilung({ body }: UpdateVerteilungRequest): Observable<VerteilungResponseDTO>
    updateVerteilung({ body }: UpdateVerteilungRequest, opts?: OperationOpts): Observable<AjaxResponse<VerteilungResponseDTO>>
    updateVerteilung({ body }: UpdateVerteilungRequest, opts?: OperationOpts): Observable<VerteilungResponseDTO | AjaxResponse<VerteilungResponseDTO>> {
        throwIfNullOrUndefined(body, 'body', 'updateVerteilung');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<VerteilungResponseDTO>({
            url: '/eDok/api/v1/BT-drucksache/verteilung',
            method: 'PUT',
            headers,
            body: body as any,
        }, opts?.responseOpts);
    };

}
